﻿// -*- C++ -*-
/*!
 * @file  MotionTest.cpp
 * @brief Motion Comp
 * @date $Date$
 *
 * $Id$
 */

#include "MotionTest.h"

// Module specification
// <rtc-template block="module_spec">
static const char* motion_spec[] =
  {
    "implementation_id", "MotionTest",
    "type_name",         "MotionTest",
    "description",       "Motion Comp",
    "version",           "1.0.0",
    "vendor",            "group4",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
MotionTest::MotionTest(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_Direction2In("Direction", m_Direction2),
    m_stickIn("Joystick", m_stick),
    m_LRF2In("LRF", m_LRF2),
    m_moveOut("Move", m_move)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
MotionTest::~MotionTest()
{
}



RTC::ReturnCode_t MotionTest::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("Move", m_moveIn);
  
  // Set OutPort buffer
  addOutPort("Direction", m_Direction2Out);
  addOutPort("Joystick", m_stickOut);
  addOutPort("LRF", m_LRF2Out);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // </rtc-template>
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t MotionTest::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MotionTest::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MotionTest::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t MotionTest::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t MotionTest::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t MotionTest::onExecute(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t MotionTest::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MotionTest::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t MotionTest::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t MotionTest::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t MotionTest::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void MotionTestInit(RTC::Manager* manager)
  {
    coil::Properties profile(motion_spec);
    manager->registerFactory(profile,
                             RTC::Create<MotionTest>,
                             RTC::Delete<MotionTest>);
  }
  
};


