﻿#ifndef TROBOT_SERIAL_IO_DELEGATOR_IFACE_HPP
#define TROBOT_SERIAL_IO_DELEGATOR_IFACE_HPP

#include "TRobotConstants.hpp"
#include "TRobotBaseSensorData.hpp"

namespace TRobot
{
  ////////////////////////////////////////////////////////////////////////////////
  /*!
   *  @brief シリアルIOのOS依存部分の実装へのインタフェース
   *
   *  @copybrief
   */
  class SerialIODelegatorIface
  {
  public:
    virtual bool stopRequested()=0;
    virtual void pushSensorData(const BaseSensorData& sensorData)=0;
    virtual void popSensorData(BaseSensorData& sensorData)=0;
    virtual RetCode receiveExactNumBytes(unsigned char *buf, size_t numBytes)=0;
    virtual RetCode sendExactNumBytes(unsigned char *buf, size_t numBytes)=0;    
    virtual void sleep(unsigned int msec)=0;
  };
  
} // namespace TRobot


#endif // TROBOT_SERIAL_IO_DELEGATOR_IFACE_HPP
