﻿// -*- C++ -*-
/*!
 * @file  kinectMotionTest.cpp
 * @brief kinectMotion component
 * @date $Date$
 *
 * $Id$
 */

#include "kinectMotionTest.h"

// Module specification
// <rtc-template block="module_spec">
static const char* kinectmotion_spec[] =
  {
    "implementation_id", "kinectMotionTest",
    "type_name",         "kinectMotionTest",
    "description",       "kinectMotion component",
    "version",           "1.0.0",
    "vendor",            "grou4",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.kinect", "0",

    // Widget
    "conf.__widget__.kinect", "radio",
    // Constraints
    "conf.__constraints__.kinect", "(0,1)",

    "conf.__type__.kinect", "double",

    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
kinectMotionTest::kinectMotionTest(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_Direction2In("Direction", m_Direction2),
    m_moveOut("refVel", m_move)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
kinectMotionTest::~kinectMotionTest()
{
}



RTC::ReturnCode_t kinectMotionTest::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("refVel", m_moveIn);
  
  // Set OutPort buffer
  addOutPort("Direction", m_Direction2Out);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  bindParameter("kinect", m_kinect, "0");
  // </rtc-template>
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t kinectMotionTest::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t kinectMotionTest::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t kinectMotionTest::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t kinectMotionTest::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t kinectMotionTest::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t kinectMotionTest::onExecute(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t kinectMotionTest::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t kinectMotionTest::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t kinectMotionTest::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t kinectMotionTest::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t kinectMotionTest::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void kinectMotionTestInit(RTC::Manager* manager)
  {
    coil::Properties profile(kinectmotion_spec);
    manager->registerFactory(profile,
                             RTC::Create<kinectMotionTest>,
                             RTC::Delete<kinectMotionTest>);
  }
  
};


